% distortion.m
% Add harmonics to sinusoidal input using non-linear transform function 
% Show output waveform for sinusoidal input and FFT
% Note that harmonic 3 is 80 per cent of harmonic 1.
% Written by: Richard Sikora. 3rd February 2005

x = 0 : 4 * pi/256 : 4 * pi;

% Try changing gain from 1.000 in line below in range 0.000 to 1.000
signal = 1.000 * sin(x);

% Set up series of coefficients for x axis
x_axis = 0 : 1/256 : 1.000 ;

% Coefficients y = a * x + b * x ^ 2
a = 4.000;
b = 4.000;

threshold = 10000/32767

for i = 1:257
    
  if ( signal(i) >= 0.0 )
     output(i) = a * signal(i) - b * signal(i) * signal(i);
     
     if output(i) > threshold
         output(i) = threshold
     end
     y(i) = a * x_axis(i) - b * x_axis(i) * x_axis(i); 

  end

  if ( signal(i) < 0.0)
      output(i) = a * signal(i) + b * signal(i) * signal(i);

     if output(i) < -threshold
         output(i) = -threshold
     end
      
      y(i) = a * x_axis(i) - b * x_axis(i) * x_axis(i);

     end
  end
   
 end

subplot (3,1,1);

plot ( x_axis, output ), grid on; 

title ('Distortion Output for Sine Input');
ylabel ('Magnitude');

subplot (3,1,2);

Y = fft(output);

harmonic = abs(Y(1:25))/ abs(Y(3));

xaxis = 0 : 0.5 : 25; 
stem ( xaxis(1:25), harmonic(1:25));

title ('Harmonic Content');
ylabel ('Magnitude');

set (gca, 'XTick', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
xlabel ('Harmonic');

subplot (3,1,3);

plot ( x_axis, y ), grid on; 

title ('Transfer Function y = 4*x + 4*x*x');
xlabel ('x axis');
ylabel ('y axis');

Harmonic_1 = harmonic(3)
Harmonic_2 = harmonic(5)
Harmonic_3 = harmonic(7)
Harmonic_4 = harmonic(9)
Harmonic_5 = harmonic(11)
Harmonic_6 = harmonic(13)
Harmonic_7 = harmonic(15)
Harmonic_8 = harmonic(17)
