% guitar_decay.m
% Add harmonics to sinusoidal input using non-linear transform function 
% Show output waveform for decaying sinusoidal input
% Note that output dies away more slowly at the expense of some distortion
% Written by: Richard Sikora. 3rd January 2005


x = 0 : 32 * pi/256 : 32 * pi

% Generate a sine wave
sinewave = sin(x);

% Generate exponential decay for envelope
exponent = exp(-x/30);

% Try changing gain from 1.000 in line below in range 0.000 to 1.000
 for i = 1 : 257
  signal(i) = 1.000 * sinewave(i) * exponent(i) ;
 end
  
% Set up series of coefficients for x axis
x_axis = 0 : 1/256 : 1.000 ;

% Coefficients y = a * x + b * x ^ 2
a = 2.00;
b = 1.00;

for i = 1:257
    
  if ( signal(i) >= 0.0 )
     output(i) = a * signal(i) - b * signal(i) * signal(i);
     y(i) = a * x_axis(i) - b * x_axis(i) * x_axis(i);   
  end

  if ( signal(i) < 0.0)
      output(i) = a * signal(i) + b * signal(i) * signal(i);
     y(i) = a * x_axis(i) - b * x_axis(i) * x_axis(i);
  end
   
 end

subplot (2,1,1);

plot ( x_axis, signal ), grid on; 

title ('Note Played on Guitar');
ylabel ('Magnitude');
xlabel ('Time');

subplot (2,1,2);
xaxis = 0 : 0.5 : 25; 
plot ( x_axis, output), grid on;

title ('Sustain Effect of Valve (Tube) Sound');
ylabel ('Magnitude');
xlabel ('Time');
set (gca, 'ylim', [-1.5, 1.5]);

%subplot (3,1,1);

%plot ( x_axis, y ), grid on; 

%title ('Transfer Function of Valve (Tube) Amplifier');
%xlabel ('Input');
%ylabel ('Output');


Harmonic_1 = harmonic(3)
Harmonic_2 = harmonic(5)
Harmonic_3 = harmonic(7)
Harmonic_4 = harmonic(9)
Harmonic_5 = harmonic(11)
Harmonic_6 = harmonic(13)
Harmonic_7 = harmonic(15)
Harmonic_8 = harmonic(17)