% fuzz.m
% Clipping at 0.7V applied to a pure tone 
% Show output waveform for sinusoidal input and FFT
% Written by: Richard Sikora. 28th November 2004

x = 0 : 4 * pi/256 : 4 * pi;

% Generate sine wave 
signal = 4 * sin(x);

for i = 1:257
 output(i) = signal(i);
  
  % Clip if input is greater than 0.7
  if ( signal(i) > 0.7)
    output(i) = 0.7;
  end

  % Clip if input is less than 0.7
  if ( signal(i) < -0.7)
     output(i) = -0.7;
  end
 
 end

subplot (3,1,1);
plot ( x, signal), grid on; 
title ('Sine Input');
ylabel ('Magnitude');
xlabel ('Time');

subplot (3,1,2);
plot ( x, output), grid on; 

title ('Fuzz Output');
ylabel ('Magnitude');
xlabel ('Time');

subplot (3,1,3);
% Find freqency components of input
y = fft(output);

% Scale harmonics so all are in range 0 - 1.000
harmonic = abs(y(1:25))/ abs(y(3));

xaxis = 0 : 0.5 : 25; 
stem ( xaxis(1:25), harmonic(1:25));

title ('Harmonic Content of Fuzz Output');
ylabel ('Magnitude');

set (gca, 'XTick', [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]);
xlabel ('Harmonic');

% Display harmonics in Command Window
Harmonic_1 = harmonic(3)
Harmonic_2 = harmonic(5)
Harmonic_3 = harmonic(7)
Harmonic_4 = harmonic(9)
Harmonic_5 = harmonic(11)
Harmonic_6 = harmonic(13)
Harmonic_7 = harmonic(15)
Harmonic_8 = harmonic(17)